window.onload = function() {
	function viewModel() {
		this.data = getData(10);
		this.menu = null;
		this.grid = null;
		var currentItem = null;
		this.menuItemClicked = function(model, s, e) {
			alert('You clicked on: ' + s.selectedItem.header + '\nDataItem is: ' + JSON.stringify(currentItem));
		};

		this.initMenu = function(model, menu) {
			model.menu = menu;
		};

		this.initGrid = function(model, grid) {
			model.grid = grid;

			// bind context menu
			grid.hostElement.addEventListener(
				"contextmenu",
				function(e) {
					var menu = model.menu;
					if (menu) {
						let hitTestInfo = grid.hitTest(e);
						let dataItem =
							hitTestInfo.panel.rows[hitTestInfo.row].dataItem;
						currentItem = dataItem;
						menu.collectionView.filter = function(item) {
							if(hitTestInfo.row % 2 === 0 && item.header === 'Odd Rows') {
								return false;
							}
							else if(hitTestInfo.row % 2 !== 0 && item.header === 'Even Rows') {
								return false;
							}
							return true;
						}
						menu.owner = grid.hostElement;
						event.preventDefault();
						menu.show(e);
					} else {
						console.log("menu not found");
					}
				},
				true
			);
		};
	}

	ko.applyBindings(new viewModel());

	// generate some random data
	function getData(count) {
		var countries = "US,Germany,UK,Japan,Italy,Greece".split(","),
			data = [];
		for (var i = 0; i < count; i++) {
			data.push({
				id: i,
				country: countries[i % countries.length],
				test: [{ p: "xxxdddd" }, { p: "holger" }],
				test1: "test1",
				boolean: true,
				time: new Date("2014-11-25T15:32:14Z"),
				active: i % 4 == 0
			});
		}
		return data;
	}
};
